/*
Copyright The KCP Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"

	v1alpha1 "github.com/kcp-dev/kcp/pkg/apis/tenancy/v1alpha1"
)

// FakeWorkspaceShards implements WorkspaceShardInterface
type FakeWorkspaceShards struct {
	Fake *FakeTenancyV1alpha1
}

var workspaceshardsResource = schema.GroupVersionResource{Group: "tenancy.kcp.dev", Version: "v1alpha1", Resource: "workspaceshards"}

var workspaceshardsKind = schema.GroupVersionKind{Group: "tenancy.kcp.dev", Version: "v1alpha1", Kind: "WorkspaceShard"}

// Get takes name of the workspaceShard, and returns the corresponding workspaceShard object, and an error if there is any.
func (c *FakeWorkspaceShards) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha1.WorkspaceShard, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootGetAction(workspaceshardsResource, name), &v1alpha1.WorkspaceShard{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.WorkspaceShard), err
}

// List takes label and field selectors, and returns the list of WorkspaceShards that match those selectors.
func (c *FakeWorkspaceShards) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha1.WorkspaceShardList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootListAction(workspaceshardsResource, workspaceshardsKind, opts), &v1alpha1.WorkspaceShardList{})
	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1alpha1.WorkspaceShardList{ListMeta: obj.(*v1alpha1.WorkspaceShardList).ListMeta}
	for _, item := range obj.(*v1alpha1.WorkspaceShardList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested workspaceShards.
func (c *FakeWorkspaceShards) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewRootWatchAction(workspaceshardsResource, opts))
}

// Create takes the representation of a workspaceShard and creates it.  Returns the server's representation of the workspaceShard, and an error, if there is any.
func (c *FakeWorkspaceShards) Create(ctx context.Context, workspaceShard *v1alpha1.WorkspaceShard, opts v1.CreateOptions) (result *v1alpha1.WorkspaceShard, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootCreateAction(workspaceshardsResource, workspaceShard), &v1alpha1.WorkspaceShard{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.WorkspaceShard), err
}

// Update takes the representation of a workspaceShard and updates it. Returns the server's representation of the workspaceShard, and an error, if there is any.
func (c *FakeWorkspaceShards) Update(ctx context.Context, workspaceShard *v1alpha1.WorkspaceShard, opts v1.UpdateOptions) (result *v1alpha1.WorkspaceShard, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateAction(workspaceshardsResource, workspaceShard), &v1alpha1.WorkspaceShard{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.WorkspaceShard), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeWorkspaceShards) UpdateStatus(ctx context.Context, workspaceShard *v1alpha1.WorkspaceShard, opts v1.UpdateOptions) (*v1alpha1.WorkspaceShard, error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateSubresourceAction(workspaceshardsResource, "status", workspaceShard), &v1alpha1.WorkspaceShard{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.WorkspaceShard), err
}

// Delete takes name of the workspaceShard and deletes it. Returns an error if one occurs.
func (c *FakeWorkspaceShards) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewRootDeleteActionWithOptions(workspaceshardsResource, name, opts), &v1alpha1.WorkspaceShard{})
	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeWorkspaceShards) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewRootDeleteCollectionAction(workspaceshardsResource, listOpts)

	_, err := c.Fake.Invokes(action, &v1alpha1.WorkspaceShardList{})
	return err
}

// Patch applies the patch and returns the patched workspaceShard.
func (c *FakeWorkspaceShards) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.WorkspaceShard, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootPatchSubresourceAction(workspaceshardsResource, name, pt, data, subresources...), &v1alpha1.WorkspaceShard{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.WorkspaceShard), err
}
